<template>
  <div>
    <v-card flat class="pa-10">
      <v-row justify="center">
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchGruposUsuario"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
            </v-toolbar>
            <v-list
              height="300"
              max-height="300"
              style="overflow: auto;"
              subheader
            >
              <v-subheader>GRUPOS DONDE SE ENCUENTRA EL USUARIO</v-subheader>
              <v-list-item-group
                v-model="selectedGruposUsuario"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedGruposUsuario"
                  :key="indexItem"
                >
                  <template v-slot:default="{ active }">
                    <v-list-item-avatar>
                      <v-icon large>mdi-account-group-outline</v-icon>
                    </v-list-item-avatar>
                    <v-list-item-content>
                      <v-list-item-title>
                        <router-link
                          class="text-decoration-underline"
                          :to="toGroup(item.grupo)"
                        >
                          {{ item.grupo.descripcion }}
                        </router-link>
                      </v-list-item-title>
                    </v-list-item-content>
                    <v-list-item-action>
                      <v-tooltip bottom>
                        <template v-slot:activator="{ on, attrs }">
                          <v-btn
                            class="white--text"
                            color="grey"
                            v-bind="attrs"
                            v-on="on"
                            @click="deleteGrupoUsuario(indexItem, item)"
                          >
                            <v-icon>mdi-exit-to-app</v-icon>
                          </v-btn>
                        </template>
                        <span>Salir del grupo</span>
                      </v-tooltip>
                    </v-list-item-action>
                  </template>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
        <v-col :cols="12" :sm="12" :md="6" :lg="6" :xl="6">
          <v-card class="mx-auto">
            <v-toolbar color="grey" dark>
              <v-spacer></v-spacer>
              <v-text-field
                v-model="searchGruposDisponibles"
                label="Buscar"
                flat
                dark
                solo-inverted
                append-icon="mdi-magnify"
                hide-details
                clear-icon="mdi-close-circle-outline"
              ></v-text-field>
            </v-toolbar>
            <v-list
              height="300"
              max-height="400"
              style="overflow: auto;"
              subheader
            >
              <v-subheader>GRUPOS PARA UNIRSE</v-subheader>
              <v-list-item-group
                v-model="selectedGruposDisponibles"
                color="primary"
              >
                <v-list-item
                  :value="item"
                  v-for="(item, indexItem) in searchedGruposDisponibles"
                  :key="indexItem"
                >
                  <v-list-item-avatar>
                    <v-icon large>mdi-account-group-outline</v-icon>
                  </v-list-item-avatar>
                  <v-list-item-content>
                    <v-list-item-title>
                      <router-link
                        class="text-decoration-underline"
                        :to="toGroup(item.grupo)"
                      >
                        {{ item.grupo.descripcion }}
                      </router-link>
                    </v-list-item-title>
                  </v-list-item-content>
                  <v-list-item-action>
                    <v-tooltip bottom>
                      <template v-slot:activator="{ on, attrs }">
                        <v-btn
                          class="white--text"
                          color="grey"
                          v-bind="attrs"
                          v-on="on"
                          @click="postGrupoUsuario(indexItem, item)"
                        >
                          <v-icon>mdi-arrow-left-box</v-icon>
                        </v-btn>
                      </template>
                      <span>Unir al grupo</span>
                    </v-tooltip>
                  </v-list-item-action>
                </v-list-item>
              </v-list-item-group>
            </v-list>
          </v-card>
        </v-col>
      </v-row>
    </v-card>
  </div>
</template>
<script>
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  name: "Component-Grupos",
  props: ["usuarioIn"],
  data() {
    return {
      searchGruposUsuario: null,
      searchGruposDisponibles: null,
      selectedGruposUsuario: null,
      selectedGruposDisponibles: null,
      gruposUsuario: [],
      gruposDisponibles: [],
      usuario: null,
    };
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    searchedGruposDisponibles() {
      let tempData = this.gruposDisponibles;
      if (this.searchGruposDisponibles != "" && this.searchGruposDisponibles) {
        tempData = tempData.filter((item) => {
          return item.grupo.descripcion
            .toUpperCase()
            .includes(this.searchGruposDisponibles.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.grupo.descripcion.toLowerCase();
          let fb = b.grupo.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
    searchedGruposUsuario() {
      let tempData = this.gruposUsuario;
      if (this.searchGruposUsuario != "" && this.searchGruposUsuario) {
        tempData = tempData.filter((item) => {
          return item.grupo.descripcion
            .toUpperCase()
            .includes(this.searchGruposUsuario.toUpperCase());
        });
      }
      if (tempData.length > 0) {
        tempData = tempData.sort((a, b) => {
          let fa = a.grupo.descripcion.toLowerCase();
          let fb = b.grupo.descripcion.toLowerCase();
          if (fa < fb) {
            return -1;
          }
          if (fa > fb) {
            return 1;
          }
          return 0;
        });
      }
      return tempData;
    },
  },
  methods: {
    toGroup(grupo) {
      return {
        name: "modelo_negocio_accesos_grupos_edicion",
        params: {
          grupo: this.serviceCommons.objectToBase64(grupo),
        },
      };
    },
    deleteGrupoUsuario(indexItem, grupoUsuario) {
      axios
        .delete(
          "/modelo-negocio/accesos/usuarios/v1/" +
            this.usuario.numeroEmpleado +
            "/grupos/" +
            grupoUsuario.idGrupoUsuario
        )
        .then((response) => {
          grupoUsuario.idGrupoUsuario = null;
          this.gruposUsuario.splice(indexItem, 1);
          this.gruposDisponibles.push(grupoUsuario);
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {});
    },
    postGrupoUsuario(indexItem, grupoUsuario) {
      let body = {
        idGrupo: grupoUsuario.grupo.idGrupo,
      };
      axios
        .post(
          "/modelo-negocio/accesos/usuarios/v1/" +
            this.usuario.numeroEmpleado +
            "/grupos",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            grupoUsuario.idGrupoUsuario = data.resultado.id;
            this.gruposUsuario.push(grupoUsuario);
            this.gruposDisponibles.splice(indexItem, 1);
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {});
    },
    getGruposUsuario() {
      this.loading = true;
      axios(
        "/modelo-negocio/accesos/usuarios/v1/" +
          this.usuario.numeroEmpleado +
          "/grupos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.gruposUsuario = data.resultado.grupos;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.gruposUsuario = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
    getGruposDisponibles() {
      this.loading = true;
      axios(
        "/modelo-negocio/accesos/usuarios/v1/" +
          this.usuario.numeroEmpleado +
          "/grupos/disponibles"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.gruposDisponibles = data.resultado.grupos;
          }
        })
        .catch((error) => {
          if (error.response && error.response.status == 404) {
            this.gruposDisponibles = [];
          } else {
            console.log(error);
          }
        })
        .finally(() => {
          this.loading = false;
        });
    },
  },
  created() {
    this.usuario = this.usuarioIn;
    this.getGruposUsuario();
    this.getGruposDisponibles();
  },
};
</script>
